﻿Imports Steema.TeeChart
Imports Steema.TeeChart.Drawing

Public Class Form1

    Public Axis(3) As Steema.TeeChart.Axis

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim aa As Integer

        InitializeChart()

        For aa = 0 To 7     '8 Traces Available
            TChart1.Series(aa).VertAxis = Styles.VerticalAxis.Custom
            TChart1.Series(aa).XValues.DateTime = False
        Next aa
        SetupVerticalAxes()
        SetupHorizontalAxis()

        TChart1.Series(0).CustomVertAxis = TChart1.Axes.Custom(0)
        TChart1.Series(1).CustomVertAxis = TChart1.Axes.Custom(1)
        TChart1.Series(2).CustomVertAxis = TChart1.Axes.Custom(2)
        TChart1.Series(3).CustomVertAxis = TChart1.Axes.Custom(0)
        TChart1.Series(4).CustomVertAxis = TChart1.Axes.Custom(1)
        TChart1.Series(5).CustomVertAxis = TChart1.Axes.Custom(2)
        TChart1.Series(6).CustomVertAxis = TChart1.Axes.Custom(0)
        TChart1.Series(7).CustomVertAxis = TChart1.Axes.Custom(1)

        TChart1.Panel.MarginLeft = 28
        TChart1.Legend.Alignment = LegendAlignments.Bottom

        FastLine1.FillSampleValues()
        FastLine2.FillSampleValues()
        FastLine3.FillSampleValues()
        FastLine4.FillSampleValues()
        FastLine5.FillSampleValues()
        FastLine6.FillSampleValues()
        FastLine7.FillSampleValues()
        FastLine8.FillSampleValues()

        Button1.Text = "Numeric"
        Button2.Text = "Time"
        Button3.Text = "Editor"

    End Sub

    Sub InitializeChart()

        TChart1.Aspect.View3D = False
        TChart1.Legend.Visible = False
        TChart1.Axes.Bottom.AutomaticMaximum = False
        TChart1.Axes.Bottom.AutomaticMinimum = False
        TChart1.Axes.Bottom.Horizontal = True
        TChart1.Axes.Bottom.StartPosition = 0
        TChart1.Axes.Bottom.EndPosition = 100
        TChart1.Axes.Bottom.MinorTickCount = 4
        TChart1.Axes.Bottom.Labels.Angle = 0

        TChart1.Axes.Left.Visible = False
        TChart1.Axes.Right.Visible = False

        TChart1.Header.Text = "Job Name"

        TChart1.Draw()

    End Sub

    Sub SetupVerticalAxes()
        Dim aa As Integer
        Dim bb As Double

        For aa = 0 To 2
            Axis(aa) = New Axis(TChart1.Chart)
            TChart1.Axes.Custom.Add(Axis(aa))
            With TChart1.Axes.Custom(aa)
                .PositionUnits = PositionUnits.Pixels
                bb = aa * -50
                .RelativePosition = bb

                .OtherSide = False
                .AxisPen.Color = Color.Red
                .Grid.Visible = True
                .Title.Text = "Rate " & (aa + 1).ToString

                .Title.Angle = 90
                .AutomaticMaximum = False
                .EndPosition = 100
                .StartPosition = 0

            End With
        Next aa

        TChart1.Axes.Custom(0).SetMinMax(0, 100)
        TChart1.Axes.Custom(1).SetMinMax(0, 200)
        TChart1.Axes.Custom(2).SetMinMax(0, 500)
        TChart1.Draw()

    End Sub

    Sub SetupHorizontalAxis()
        'Bottom Axis

        TChart1.Axes.Bottom.Minimum = 0
        TChart1.Axes.Bottom.Maximum = 60
        TChart1.Axes.Bottom.AxisPen.Color = Color.Blue
        TChart1.Axes.Bottom.Labels.Font.Color = Color.Black

        TChart1.Axes.Bottom.Horizontal = True
        TChart1.Axes.Bottom.StartPosition = 0
        TChart1.Axes.Bottom.EndPosition = 100
        TChart1.Axes.Bottom.Labels.ValueFormat = "#,##0"
        TChart1.Axes.Bottom.Labels.Angle = 0

        AddHandler TChart1.BeforeDrawAxes, AddressOf BeforeDraw
        TChart1.Draw()

    End Sub

    Private Sub BeforeDraw(sender As Object, g As Graphics3D)
        Dim aa As Integer

        TChart1.AutoRepaint = False
        For aa = 0 To 2
            If (TChart1.Series(aa).CustomVertAxis IsNot Nothing) Then
                TChart1.Series(aa).CustomVertAxis.Visible = TChart1.Series(aa).Active
            End If
        Next aa
        TChart1.AutoRepaint = True

    End Sub

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        'Numeric Mode
        Dim aa As Integer

        For aa = 0 To 7
            TChart1.Series(aa).XValues.DateTime = False
        Next aa
        TChart1.Axes.Bottom.Labels.ValueFormat = "#,##0"
        TChart1.Axes.Bottom.Minimum = 0
        TChart1.Axes.Bottom.Maximum = 60
        TChart1.Axes.Bottom.Labels.Angle = 0
        TChart1.Axes.Bottom.Increment = (TChart1.Axes.Bottom.Maximum - TChart1.Axes.Bottom.Minimum) / 12

    End Sub

    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        'Time Mode
        Dim aa As Integer
        Dim bb As DateTime
        Dim cc As DateTime

        For aa = 0 To 7
            TChart1.Series(aa).XValues.DateTime = True
        Next aa

        TChart1.Axes.Bottom.Labels.DateTimeFormat = "MM/dd/yyyy HH:mm"
        TChart1.Axes.Bottom.Labels.Angle = 90
        bb = Now
        cc = bb.AddMinutes(60)
        TChart1.Axes.Bottom.Minimum = bb.ToOADate()
        TChart1.Axes.Bottom.Maximum = cc.ToOADate()
        TChart1.Axes.Bottom.Increment = (TChart1.Axes.Bottom.Maximum - TChart1.Axes.Bottom.Minimum) / 12

    End Sub

    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click

        Editor1.ShowModal()

    End Sub

End Class
